package net.minecraft.src;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.LinkedList;

import net.minecraft.client.Minecraft;

import immibis.core.*;
import immibis.core.covers.CoverSystemProxy;
import immibis.core.covers.CoversNonSharedProxy;
import immibis.core.covers.ICoverableTile;
import immibis.core.covers.TileMultipart;

public class mod_ImmibisCore extends CompatibleBaseMod {

	@Override
	public String getVersion() {
		return ModInfoReader.getModInfoField("/immibis/core/mod_ImmibisCore.info.txt", "version");
	}
	
	private int coverModel;
	
	public static boolean coversEnabled;

	@Override
	public void load() {
		CoreProxy.load();
		if(Config.getBoolean("enableMicroblocks", false))
		{
			coverModel = ModLoader.getUniqueBlockModelID(this, true);
			CoverSystemProxy.init(coverModel);
			coversEnabled = true;
		}
		else
			coversEnabled = false;
	}
	
	@Override
	public boolean renderWorldBlock(RenderBlocks render, IBlockAccess world, int x, int y, int z, Block block, int model)
	{
		if(model == coverModel && coversEnabled)
			CoversNonSharedProxy.RenderWorldBlock(render, world, x, y, z, block);
		else if(model == BlockMultiTile.model)
			return ((BlockMultiTile)block).renderStatic(render, world, x, y, z);
		return false; // no second pass required
	}
	
	@Override
	public void renderInvBlock(RenderBlocks render, Block block, int meta, int model) {
		if(model == coverModel && coversEnabled)
			CoversNonSharedProxy.RenderInvBlock(render, block, meta);
		else if(model == BlockMultiTile.model)
			((ItemBlockMultiTile)Item.itemsList[block.blockID]).renderItem(render, meta);
	}
	
	@Override
	public void modsLoaded() {
		CoreProxy.AllocateBlockIDs();
		if(coversEnabled)
			CoverSystemProxy.ModsLoaded();
	}
	
	public static mod_ImmibisCore instance;
	
	public mod_ImmibisCore() {
		instance = this;
	}

}
