package net.minecraft.src;

import java.io.IOException;
import java.lang.reflect.Method;

import net.minecraft.src.forge.*;

import immibis.core.*;
import immibis.core.covers.BlockMultipart;
import immibis.core.covers.CoverSystemProxy;
import immibis.core.covers.EnumPosition;
import immibis.core.covers.ItemMultipart;

public class mod_ImmibisCore extends CompatibleBaseMod
{

	@Override
	public String getVersion() {
		return ModInfoReader.getModInfoField("/immibis/core/mod_ImmibisCore.info.txt", "version");
	}
	
	public static boolean coversEnabled = true;
	
	private boolean loaded = false;
	
	@Override
	public void load() {
		if(loaded) return;
		loaded = true;
		
		CoreProxy.load();
		
		if(Config.getBoolean("enableMicroblocks", false)) {
			CoverSystemProxy.init(0);
			coversEnabled = true;
		} else
			coversEnabled = false;
	}
	
	@Override
	public void modsLoaded() {
		CoreProxy.AllocateBlockIDs();
		if(coversEnabled)
			CoverSystemProxy.ModsLoaded();
	}
	
	public static mod_ImmibisCore instance;
	
	public mod_ImmibisCore() {
		instance = this;
	}
	
	/*@Override
	public void handlePacket(Packet230ModLoader packet, EntityPlayerMP ply)
	{
		if(packet.packetType == CoreProxy.PACKET_TYPE_C2S_MICROBLOCK_DIG_START)
			BlockMultipart.setPunchingSubhit(ply, packet.dataInt[3]);
		else if(packet.packetType == CoreProxy.PACKET_TYPE_C2S_MICROBLOCK_PLACE)
		{
			if(packet.dataInt.length != 4)
				return;
			int x = packet.dataInt[0];
			int y = packet.dataInt[1];
			int z = packet.dataInt[2];
			int posid = packet.dataInt[3];
			if(posid < 0 || posid >= EnumPosition.values().length)
				return;
			EnumPosition pos = EnumPosition.values()[posid];
			ItemStack h = ply.getCurrentEquippedItem();
			if(h == null || !(Item.itemsList[h.itemID] instanceof ItemMultipart))
				return;
			ItemMultipart i = (ItemMultipart)Item.itemsList[h.itemID];
			i.placeInBlock(ply.worldObj, x, y, z, pos, h);
			ply.worldObj.markBlockNeedsUpdate(x, y, z);
			if(h.stackSize == 0)
				ply.destroyCurrentEquippedItem();
		}
	}*/
}
